Subject: Re: bug#62333: 30.0.50; Issue with tree-sitter syntax tree during certain changes

From: Eli Zaretskii <[email-masked]>
Date: Sat, 25 Mar 2023 17:41:49 +0300

> Date: Sat, 25 Mar 2023 16:18:12 +0200
> Cc: [email-masked], [email-masked], [email-masked]
> From: Dmitry Gutov <[email-masked]>
> 
> > mixed-major-mode shouldn't be a problem.
> 
> Why wouldn't it?

Because the sexp ends inside the current mode's block.

> >> Long lines?
> > 
> > Easy to test, and the call to widen will do nothing anyway in that
> > case.
> 
> Okay. Because of locked narrowing, I guess.

Yes.

> >> Because if we wanted to widen in all similar situations, we might as
> >> well make it not obey the narrowing at all.
> > 
> > It is impossible to not obey narrowing, not in Emacs.  I told that and
> > explained that many times already, including simple examples of what
> > trouble this could cause to even the most innocent Lisp code.  I hoped
> > that by now this should no longer be brought forward.
> 
> Okay. But do you advocate all uses of tree-sitter to (widen) first?

No, just in sexp-movement functions, at least for now.  If we discover
this is need in many more situations, we might consider more drastic
measures.  But I don't think we are there yet.  We've discovered just
one such case, in just one such mode, and it's on master.  We still
have ample time to see how widespread this is.